/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: base.cpp,v 1.3 1997/06/24 17:27:08 reichel Exp $ *
 ***********************************************************************/
// ----------------------------------------------------------------------------------------------------------
//	What   : Domain Knowledge Representation with *FLIP++
//	Project: DomFLIP++
//	Author : Andreas Raggl
//	Start  : 02.12.1996
//	Last   : 14.01.1997
// 	File   : base.cpp
// ----------------------------------------------------------------------------------------------------------

#include "base.h"

// global functions

ostream& space( ostream& os )
{
    return os << ' ';
};

ostream& operator<<		( ostream& os, CBase& c )
{
	c.Write( os );	
	return os;
};

istream& operator>>		( istream& is, CBase& c )
{
	c.Read( is );
	return is;
};


// class definition of CBase

CBase::CBase			( char* s, long l )	: classversion( l )
{
	strcpy( classname, s );
};
	
CBase::~CBase			()	
{};

void CBase::Read		( istream& is )
{
	long version;
	namestr name;
	
	is >> version;
	if ( version == 0 )
	{
		is >> name >> version;
		if ( strcmp( name, classname ) != 0 )
		{	
			cout << "error\n";
cout << name << space << classname << endl;
		}
	}
	classversion = version;			
	switch( classversion)
	{
	case 1: 
		break;
	default:
		;
	}
};

void CBase::Write		( ostream& os ) const
{
	os << (long)0 << space << classname << space << classversion << endl;
};
