/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: main.cpp,v 1.3 1997/06/24 17:27:31 reichel Exp $ *
 ***********************************************************************/
// ----------------------------------------------------------------------------------------------------------
//	What   : Domain Knowledge Representation with *FLIP++
//	Project: DomFLIP++
//	Author : Andreas Raggl
//	Start  : 10.12.1996
//	Last   : 31.01.1997
//	File   : main.cpp
// ----------------------------------------------------------------------------------------------------------

#include "domflip.h"
#include "optimize.h"

#ifdef _MSC_VER
#include <crtdbg.h>
#endif

int main()
{
	CShiftSchedulingDomain cDomain;
	COptimize cOptimizer( &cDomain );
	
#ifdef _MSC_VER
#ifdef _DEBUG
	_CrtMemState s1, s2, s3;
	_CrtMemCheckpoint( &s1 );
#endif
#endif
	while ( 1 )
	{
		int choice = 0;
		char filename[256];
		cout << "DomFLIP++ - Shift scheduling" << endl;
		cout << endl;
		cout << "1> Read domain data" << endl;
		cout << "2> Write domain data" << endl;
		cout << "3> Optimize with iterative deepening" << endl;
		cout << "4> Optimize with random repair" << endl;
		cout << "5> Write domain variables" << endl;
		cout << "6> Quit" << endl;
		cout << endl;
		cout << "Hit number key to choose an item." << endl;
		cin  >> choice;
		switch ( choice )
		{
		case 1:
			cout << "Filename: "; 
			cin >> filename;
			cDomain.Read( filename );
			break;
		case 2:
			cout << "Filename: "; 
			cin >> filename;
			cDomain.Write( filename );
			break;
		case 3:
			cOptimizer.RepairDeep();
			break;
		case 4:
			cOptimizer.RepairRandom();
			break;
		case 5:
			cout << "Filename: "; 
			cin >> filename;
			cDomain.WriteVariables( filename );
			break;
		case 6:
#ifdef _MSC_VER
#ifdef _DEBUG
	_CrtMemCheckpoint( &s2 );
	if ( _CrtMemDifference( &s3, &s1, &s2 ) )
		_CrtMemDumpStatistics( &s3 );
	_CrtDumpMemoryLeaks( );
#endif
#endif
			return 0;
			break;
		default:
			cout << "Illegal choice" << endl;
		}
	}

}
